package jp.hishidama.ant.types.htlex;

import java.util.List;

import jp.hishidama.html.lexer.token.AttributeToken;
import jp.hishidama.html.lexer.token.ListToken;
import jp.hishidama.html.lexer.token.Tag;

import org.apache.tools.ant.BuildException;

/**
 * HtHtmlLexer^O^Cv.
 *<p>
 * HTMLt@C̃^Ȏ̑Ǘf[^^CvB
 * </p>
 *
 * @author <a target="hishidama" href=
 *         "http://www.ne.jp/asahi/hishidama/home/tech/soft/java/ant/htlex.html"
 *         >Ђ</a>
 * @since 2009.01.23
 */
public class AttrOpeType extends AttrType {

	protected HtLexerConverter htmlConverter;

	/**
	 * s.
	 *
	 * @param conv
	 *            Ro[^[
	 * @throws BuildException
	 *             G[
	 */
	public void validate(HtLexerConverter conv) throws BuildException {
		htmlConverter = conv;
	}

	/**
	 * ^Oϊs.
	 *
	 * @param tag
	 *            ^O
	 * @return eύXꍇAtrue
	 */
	public boolean convert(Tag tag) {
		boolean ret = false;
		List<AttributeToken> list = tag.getAttributeList();
		for (AttributeToken a : list) {
			if (matches(a)) {
				ret |= convert(tag, a);
			}
		}
		return ret;
	}

	protected boolean convert(Tag tag, AttributeToken a) {
		return false;
	}

	protected boolean delete(Tag tag, AttributeToken a) {
		ListToken r = tag.cutWithPreSkip(a);
		return r != null;
	}
}
