package jp.hishidama.ant.types.htlex;

import jp.hishidama.html.lexer.token.AttributeToken;
import jp.hishidama.html.lexer.token.Tag;

import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.types.EnumeratedAttribute;

/**
 * HtHtmlLexer^Ou^Cv.
 *<p>
 * HTMLt@C̃^Ȏ̒usf[^^CvB
 * </p>
 *
 * @author <a target="hishidama" href=
 *         "http://www.ne.jp/asahi/hishidama/home/tech/soft/java/ant/htlex.html"
 *         >Ђ</a>
 * @since 2009.01.23
 */
public class AttrRepType extends AttrNewType {

	/**
	 * d@.
	 * <p>
	 * ϊɂđdꍇ̏@w肷B
	 * </p>
	 *
	 * @version 2009.02.01
	 */
	public static class DupEnum extends EnumeratedAttribute {

		/** {@value}F̂܂܋Iɒǉȋoj */
		public static final String FORCE = "force";
		/** {@value}FύXȂ */
		public static final String SKIP = "skip";
		/** {@value}F̑폜AV𐶂 */
		public static final String UPDATE = "update";
		/** {@value}FG[Ƃ */
		public static final String ERROR = "error";
		/** {@value}Fϊ悤ƂĂ폜 */
		public static final String DELETE = "delete";

		@Override
		public String[] getValues() {
			return new String[] { FORCE, SKIP, UPDATE, ERROR, DELETE };
		}

		public DupEnum() {
		}

		private DupEnum(String s) {
			setValue(s);
		}
	}

	protected DupEnum dup = new DupEnum(DupEnum.UPDATE);

	/**
	 * Odݒ.
	 *
	 * @param d
	 *            d@
	 */
	public void setDup(DupEnum d) {
		dup = d;
	}

	@Override
	public boolean convert(Tag tag, AttributeToken a) throws BuildException {
		if (newName != null) {
			AttributeToken old = tag.getAttribute(newName);
			if (old != null && old != a) {
				switch (dup.getIndex()) {
				case 0:// force
					break;
				case 1:// skip
					return false;
				default:// update
					return delete(tag, old) | update(tag, a);
					// case ?:
					// return delete(tag, a) | update(tag, old);
				case 3: // error
					throw new BuildException("duplicate attribute (replace): "
							+ htmlConverter.getReadFile().getAbsolutePath()
							+ ":" + +old.getLine() + " " + newName,
							getLocation());
				case 4:// delete
					return delete(tag, a);
				}
			}
		}

		return update(tag, a);
	}
}
