package jp.hishidama.ant.types.htlex;

import jp.hishidama.html.HtmlEscape;

import org.apache.tools.ant.types.EnumeratedAttribute;

/**
 * HTMLGXP[v@NX.
 *<p>
 * HTMLGXP[v̕@ǗNXB
 * </p>
 *
 * @author <a target="hishidama" href=
 *         "http://www.ne.jp/asahi/hishidama/home/tech/soft/java/ant/htlex.html"
 *         >Ђ</a>
 * @since 2009.01.25
 * @version 2009.02.01
 * @see HtmlEscape
 */
public class HtmlEscapeEnum extends EnumeratedAttribute {

	/** {@value}F{ */
	public static final String BASE = "base";
	/** {@value}F{{_uNH[e[V */
	public static final String DQ = "dq";
	/** {@value}F{{VONH[e[V */
	public static final String SQ = "sq";
	/** {@value}FS */
	public static final String ALL = "all";

	@Override
	public String[] getValues() {
		return new String[] { BASE, DQ, SQ, ALL };
	}

	public HtmlEscapeEnum() {
	}

	public HtmlEscapeEnum(String s) {
		setValue(s);
	}

	/**
	 * @return _uNH[e[VϊꍇAtrue
	 */
	public boolean isDq() {
		int i = getIndex();
		return (i == 1 || i == 3);
	}

	/**
	 * @return VONH[e[VϊꍇAtrue
	 */
	public boolean isSq() {
		int i = getIndex();
		return (i == 2 || i == 3);
	}
}
