package jp.hishidama.html;

import java.util.*;

/**
 * HTMLGXP[vNX.
 * <p>
 * HTMLGXP[viHTMLGR[hj̔ssB
 * </p>
 *
 * @author <a target="hishidama" href=
 *         "http://www.ne.jp/asahi/hishidama/home/tech/soft/java/htlexer.html"
 *         >Ђ</a>
 * @since 2009.01.25
 * @version 2009.02.08
 */
public class HtmlEscape {

	/**
	 * RXgN^[.
	 *<p>
	 * {@link #HtmlEscape(boolean, boolean) RXgN^[}ɑStruew肵ꍇƓB
	 * </p>
	 *
	 * @see #HtmlEscape(boolean, boolean)
	 */
	public HtmlEscape() {
		this(true, true);
	}

	/**
	 * RXgN^[.
	 * <table border="1">
	 * <caption>ftHgŎw肳镶</caption>
	 * <tr>
	 * <th></th>
	 * <th>ϊ</th>
	 * <th>l</th>
	 * <th>version</th>
	 * </tr>
	 * <tr>
	 * <td>&amp;</td>
	 * <td>&amp;amp;</td>
	 * <td>-</td>
	 * <td>&nbsp</td>
	 * </tr>
	 * <tr>
	 * <td>&lt;</td>
	 * <td>&amp;lt;</td>
	 * <td>-</td>
	 * <td>&nbsp</td>
	 * </tr>
	 * <tr>
	 * <td>&gt;</td>
	 * <td>&amp;gt;</td>
	 * <td>-</td>
	 * <td>&nbsp</td>
	 * </tr>
	 * <tr>
	 * <td>&quot;</td>
	 * <td>&amp;quot;</td>
	 * <td>dqtruȅꍇ</td>
	 * <td>&nbsp</td>
	 * </tr>
	 * <tr>
	 * <td>&#39;</td>
	 * <td>&amp;#39;</td>
	 * <td>sqtruȅꍇ</td>
	 * <td>&nbsp</td>
	 * </tr>
	 * <tr>
	 * <td>&nbsp;</td>
	 * <td>&amp;nbsp;</td>
	 * <td>̂ƂAϊΏۊO</td>
	 * <td>2009.02.08</td>
	 * </tr>
	 * <tr>
	 * <td>Ȃ</td>
	 * <td>&amp;copy;</td>
	 * <td>ϊΏۊO</td>
	 * <td>2009.02.08</td>
	 * </tr>
	 * <tr>
	 * <td>Ȃ</td>
	 * <td>&amp;reg;</td>
	 * <td>ϊΏۊO</td>
	 * <td>2009.02.08</td>
	 * </tr>
	 * </table>
	 *
	 * @param dq
	 *            truȅꍇA_uNH[e[V̒`܂߂
	 * @param sq
	 *            truȅꍇAVONH[e[V̒`܂߂
	 */
	public HtmlEscape(boolean dq, boolean sq) {
		addEntity("amp", "&");
		addEntity("lt", "<");
		addEntity("gt", ">");
		if (dq) {
			addEntity("quot", "\"");
		}
		if (sq) {
			addEntity("#39", "\'");
			// addEntity("apos", "\'");
		}

		// addEntity("nbsp", " ");
		addEntity("nbsp", null);

		addEntity("copy", null);
		addEntity("reg", null);
	}

	protected final Map<String, String> nameMap = new HashMap<String, String>();
	protected final Map<Character, String> entityMap = new HashMap<Character, String>();

	/**
	 * ENTITYǉ.
	 * <p>
	 * GeBeB[iQƂ̎́jǉB<br>
	 * GeBeB[ijɂȂ閼ÓAォǉD悳B
	 * </p>
	 *
	 * @param name
	 *            OiFampj
	 * @param entity
	 *            ́iF&amp;jBK1łKvB<br>
	 *            null̏ꍇ͕ϊΏۂƂȂB
	 */
	public void addEntity(String name, String entity) {
		nameMap.put(name, entity);
		if (entity == null) {
			return;
		}
		if (entity.length() != 1) {
			throw new IllegalArgumentException("entity.length != 1: " + entity);
		}
		entityMap.put(entity.charAt(0), "&" + name + ";");
	}

	/**
	 * ENTITY`Sč폜.
	 */
	public void clearEntities() {
		nameMap.clear();
		entityMap.clear();
	}

	/**
	 * HTMLGXP[v.
	 * <p>
	 * HTMLGXP[vsBɃGXP[vĂ镶ɂĂ͕ϊȂB
	 * </p>
	 *
	 * @param s
	 *            
	 * @return HTMLGXP[vꂽisnullꍇnullj
	 */

	public String escape(String s) {
		if (s == null) {
			return null;
		}

		StringBuilder sb = new StringBuilder(s.length() * 2);
		for (int i = 0; i < s.length();) {
			char c = s.charAt(i);
			if (c == '&') {
				String e = escapedAmp(s, i);
				if (e != null) {
					sb.append(c);
					sb.append(e);
					sb.append(';');
					i += e.length() + 2;
					continue;
				}
			}
			String name = entityMap.get(c);
			if (name != null) {
				sb.append(name);
			} else {
				sb.append(c);
			}
			i++;
		}
		return sb.toString();
	}

	/**
	 * HTMLGXP[vĂ镶ǂ𔻒肷
	 *
	 * @param s
	 *            
	 * @param pos
	 *            Jnʒuiu&amp;vʒuj
	 * @return GXP[vĂꍇA̕B<br>
	 *         GXP[vĂȂꍇ0
	 */
	public String escapedAmp(String s, int pos) {
		pos++;
		int semi = s.indexOf(';', pos + 1);
		if (semi < 0) {
			return null;
		}
		String t = s.substring(pos, semi);
		if (nameMap.containsKey(t)) {
			return t;
		}
		char c = t.charAt(0);
		switch (c) {
		case '#':
			if (t.length() < 2) {
				return null;
			}
			c = t.charAt(1);
			if (c == 'x' || c == 'X') {
				if (isHexDigits(t, 2)) {
					return t;
				} else {
					return null;
				}
			} else {
				if (isDigits(t, 1)) {
					return t;
				} else {
					return null;
				}
			}
		}
		return null;
	}

	/**
	 * \iǂ𔻒肷
	 *
	 * @param s
	 *            
	 * @param first
	 *            Jnʒu
	 * @return \ȉꍇAtrue
	 */
	public static boolean isDigits(String s, int first) {
		int len = s.length();
		for (int i = first; i < len; i++) {
			if (!isDigit(s.charAt(i))) {
				return false;
			}
		}
		return first < len;
	}

	/**
	 * \iǂ𔻒肷
	 *
	 * @param c
	 *            
	 * @return \ȉꍇAtrue
	 */
	public static boolean isDigit(char c) {
		return ('0' <= c && c <= '9');
	}

	/**
	 * \Ziǂ𔻒肷
	 *
	 * @param s
	 *            
	 * @param first
	 *            Jnʒu
	 * @return \ZȉꍇAtrue
	 */
	public static boolean isHexDigits(String s, int first) {
		int len = s.length();
		for (int i = first; i < len; i++) {
			if (!isHexDigit(s.charAt(i))) {
				return false;
			}
		}
		return first < len;
	}

	/**
	 * \Ziǂ𔻒肷
	 *
	 * @param c
	 *            
	 * @return \ZȉꍇAtrue
	 */
	public static boolean isHexDigit(char c) {
		return ('0' <= c && c <= '9') || ('a' <= c && c <= 'f')
				|| ('A' <= c && c <= 'F');
	}
}
