package jp.hishidama.html.lexer.token;

/**
 * HtHtmlLexerg[Nij.
 *<p>
 * iƑl̑gjPێg[NB
 * </p>
 *
 * @author <a target="hishidama" href=
 *         "http://www.ne.jp/asahi/hishidama/home/tech/soft/java/htlexer.html"
 *         >Ђ</a>
 * @since 2009.01.10
 * @see NameAtom
 * @see ValueToken
 */
public class AttributeToken extends ListToken {

	/**
	 * @since 2009.02.07
	 */
	@Override
	public AttributeToken clone() throws CloneNotSupportedException {
		return new AttributeToken(this);
	}

	protected AttributeToken(AttributeToken o) {
		super(o);
	}

	protected static enum Pos {
		NAME, SKIP1, LET, SKIP2, VALUE
	}

	/**
	 * RXgN^[.
	 */
	public AttributeToken() {
	}

	/**
	 * ݒ.
	 *
	 * @param name
	 *            
	 */
	public void setName(NameAtom name) {
		set(Pos.NAME, name);
	}

	/**
	 * ݒ.
	 *
	 * @param s
	 *            
	 */
	public void setName(String s) {
		NameAtom name = getNameAtom();
		if (name == null) {
			name = new NameAtom();
			setName(name);
		}
		name.setName(s);
	}

	/**
	 * 󔒐ݒ.
	 * <p>
	 * ƑL̊Ԃ̋󔒁B
	 * </p>
	 *
	 * @param skip
	 *            
	 */
	public void setSkip1(SkipToken skip) {
		set(Pos.SKIP1, skip);
	}

	/**
	 * Lݒ.
	 *
	 * @param word
	 *            L
	 */
	public void setLet(WordAtom word) {
		set(Pos.LET, word);
	}

	/**
	 * Lݒ.
	 *
	 * @param s
	 *            Liʂ́u=vj
	 */
	public void setLet(String s) {
		setLet(new WordAtom(s));
	}

	/**
	 * 󔒐ݒ.
	 * <p>
	 * LƑl̊Ԃ̋󔒁B
	 * </p>
	 *
	 * @param skip
	 *            
	 */
	public void setSkip2(SkipToken skip) {
		set(Pos.SKIP2, skip);
	}

	/**
	 * lݒ.
	 *
	 * @param value
	 *            l
	 */
	public void setValue(ValueToken value) {
		set(Pos.VALUE, value);
	}

	/**
	 * 擾.
	 *
	 * @return i݂ȂꍇAnullj
	 */
	public NameAtom getNameAtom() {
		return (NameAtom) get(Pos.NAME);
	}

	/**
	 * 擾.
	 *
	 * @return i݂ȂꍇAnullj
	 */
	public String getName() {
		NameAtom name = getNameAtom();
		if (name != null) {
			return name.getName();
		}
		return null;
	}

	/**
	 * 󔒎擾.
	 * <p>
	 * ƑL̊Ԃ̋󔒁B
	 * </p>
	 *
	 * @return 󔒁i݂ȂꍇAnullj
	 */
	public SkipToken getSkip1Token() {
		return (SkipToken) get(Pos.SKIP1);
	}

	/**
	 * 󔒎擾.
	 * <p>
	 * ƑL̊Ԃ̋󔒁B
	 * </p>
	 *
	 * @return 󔒁i݂ȂꍇAnullj
	 */
	public String getSkip1() {
		SkipToken skip1 = getSkip1Token();
		if (skip1 != null) {
			return skip1.getText();
		}
		return null;
	}

	/**
	 * L擾.
	 *
	 * @return Li݂ȂꍇAnullj
	 */
	public WordAtom getLetToken() {
		return (WordAtom) get(Pos.LET);
	}

	/**
	 * L擾.
	 *
	 * @return Li݂ȂꍇAnullj
	 */
	public String getLet() {
		WordAtom eq = getLetToken();
		if (eq != null) {
			return eq.getString();
		}
		return null;
	}

	/**
	 * 󔒎擾.
	 * <p>
	 * LƑl̊Ԃ̋󔒁B
	 * </p>
	 *
	 * @return 󔒁i݂ȂꍇAnullj
	 */
	public SkipToken getSkip2Token() {
		return (SkipToken) get(Pos.SKIP2);
	}

	/**
	 * 󔒎擾.
	 * <p>
	 * LƑl̊Ԃ̋󔒁B
	 * </p>
	 *
	 * @return 󔒁i݂ȂꍇAnullj
	 */
	public String getSkip2() {
		SkipToken skip2 = getSkip2Token();
		if (skip2 != null) {
			return skip2.getText();
		}
		return null;
	}

	/**
	 * l擾.
	 *
	 * @return li݂ȂꍇAnullj
	 */
	public ValueToken getValueToken() {
		return (ValueToken) get(Pos.VALUE);
	}

	/**
	 * l擾.
	 *
	 * @return li݂ȂꍇAnullj
	 */
	public String getValue() {
		ValueToken value = getValueToken();
		if (value != null) {
			return value.getValue();
		}
		return null;
	}
}
