package jp.hishidama.html.lexer.token;

/**
 * HtHtmlLexerg[NiCDATAj.
 *<p>
 * CDATAZNVi{@literal <![CDATA[`]]>}jێg[NB
 * </p>
 *
 * @author <a target="hishidama" href=
 *         "http://www.ne.jp/asahi/hishidama/home/tech/soft/java/htlexer.html"
 *         >Ђ</a>
 * @since 2009.01.25
 */
public class CData extends NamedMarkup {

	/**
	 * @since 2009.02.07
	 */
	@Override
	public CData clone() throws CloneNotSupportedException {
		return new CData(this);
	}

	protected CData(CData o) {
		super(o);
	}

	static enum Pos {
		TAGO, NAME, BRAO, TEXT, TAGC
	}

	/**
	 * RXgN^[.
	 */
	public CData() {
	}

	/**
	 * pʊJݒ.
	 * <p>
	 * uCDATAv̒̊pʁB
	 * </p>
	 *
	 * @param word
	 *            pʁiʂ́u[vj
	 */
	public void setBraO(WordAtom word) {
		set(Pos.BRAO, word);
	}

	/**
	 * eLXgݒ.
	 *
	 * @param text
	 *            eLXg
	 */
	public void setData(TextToken text) {
		set(Pos.TEXT, text);
	}

	@Override
	public void setTag2(StringBuilder sb) {
		AtomToken atom = getTag2Atom();
		if (atom == null) {
			atom = new AtomToken(sb);
			set(Pos.TAGC, atom);
		} else {
			atom.setAtom(sb);
		}
	}

	@Deprecated
	@Override
	public void addSkip(SkipToken skip) {
		throw new UnsupportedOperationException();
	}

	/**
	 * eLXg擾.
	 *
	 * @return eLXgi݂ȂꍇAnullj
	 */
	public String getData() {
		TextToken text = getDataToken();
		if (text != null) {
			return text.getText();
		}
		return null;
	}

	/**
	 * eLXg擾.
	 *
	 * @return eLXgi݂ȂꍇAnullj
	 */
	public TextToken getDataToken() {
		return (TextToken) get(Pos.TEXT);
	}

	@Override
	public String getTag2() {
		AtomToken atom = getTag2Atom();
		if (atom != null) {
			return atom.getAtom();
		}
		return null;
	}

	@Override
	public AtomToken getTag2Atom() {
		return (AtomToken) get(Pos.TAGC);
	}
}
