package jp.hishidama.html.lexer.token;

/**
 * HtHtmlLexerg[Nilj.
 *<p>
 * lێg[NB
 * </p>
 *
 * @author <a target="hishidama" href=
 *         "http://www.ne.jp/asahi/hishidama/home/tech/soft/java/htlexer.html"
 *         >Ђ</a>
 * @since 2009.01.10
 */
public class ValueToken extends ListToken {

	/**
	 * @since 2009.02.07
	 */
	@Override
	public ValueToken clone() throws CloneNotSupportedException {
		return new ValueToken(this);
	}

	protected ValueToken(ValueToken o) {
		super(o);
	}

	protected static enum Pos {
		BEGIN, VALUE, END
	}

	/**
	 * RXgN^[.
	 */
	public ValueToken() {
	}

	/**
	 * NH[e[Vݒ.
	 *<p>
	 * l̐擪̃NH[e[VB
	 * </p>
	 *
	 * @param sb
	 *            NH[e[V
	 */
	public void setQuote1(StringBuilder sb) {
		if (sb == null) {
			setQuote1Atom(null);
			return;
		}
		AtomToken atom = getQuote1Atom();
		if (atom == null) {
			atom = new AtomToken(sb);
			setQuote1Atom(atom);
		} else {
			atom.setAtom(sb);
		}
	}

	/**
	 * NH[e[Vݒ.
	 *<p>
	 * l̐擪̃NH[e[VB
	 * </p>
	 *
	 * @param s
	 *            NH[e[V
	 */
	public void setQuote1(String s) {
		if (s == null) {
			setQuote1Atom(null);
			return;
		}
		AtomToken atom = getQuote1Atom();
		if (atom == null) {
			atom = new AtomToken(s);
			setQuote1Atom(atom);
		} else {
			atom.setAtom(s);
		}
	}

	/**
	 * NH[e[Vݒ.
	 *<p>
	 * l̐擪̃NH[e[VB
	 * </p>
	 *
	 * @param atom
	 *            NH[e[V
	 */
	public void setQuote1Atom(AtomToken atom) {
		set(Pos.BEGIN, atom);
	}

	/**
	 * lݒ.
	 *
	 * @param text
	 *            l
	 */
	public void setValue(TextToken text) {
		set(Pos.VALUE, text);
	}

	/**
	 * NH[e[Vݒ.
	 * <p>
	 * l̖̃NH[e[VB
	 * </p>
	 *
	 * @param sb
	 *            NH[e[V
	 */
	public void setQuote2(StringBuilder sb) {
		if (sb == null) {
			setQuote2Atom(null);
			return;
		}
		AtomToken atom = getQuote2Atom();
		if (atom == null) {
			atom = new AtomToken(sb);
			setQuote2Atom(atom);
		} else {
			atom.setAtom(sb);
		}
	}

	/**
	 * NH[e[Vݒ.
	 * <p>
	 * l̖̃NH[e[VB
	 * </p>
	 *
	 * @param s
	 *            NH[e[V
	 */
	public void setQuote2(String s) {
		AtomToken atom = getQuote2Atom();
		if (atom == null) {
			atom = new AtomToken(s);
			setQuote2Atom(atom);
		} else {
			atom.setAtom(s);
		}
	}

	/**
	 * NH[e[Vݒ.
	 * <p>
	 * l̖̃NH[e[VB
	 * </p>
	 *
	 * @param atom
	 *            NH[e[V
	 */
	public void setQuote2Atom(AtomToken atom) {
		set(Pos.END, atom);
	}

	/**
	 * NH[e[V擾.
	 * <p>
	 * l̐擪̃NH[e[VB
	 * </p>
	 *
	 * @return NH[e[Vi݂ȂꍇAnullj
	 */
	public String getQuote1() {
		AtomToken q = getQuote1Atom();
		if (q == null) {
			return null;
		}
		return q.getAtom();
	}

	/**
	 * NH[e[V擾.
	 * <p>
	 * l̐擪̃NH[e[VB
	 * </p>
	 *
	 * @return NH[e[Vi݂ȂꍇAnullj
	 */
	public AtomToken getQuote1Atom() {
		return (AtomToken) get(Pos.BEGIN);
	}

	/**
	 * l擾.
	 *
	 * @return li݂ȂꍇAnullj
	 */
	public TextToken getValueToken() {
		return (TextToken) get(Pos.VALUE);
	}

	/**
	 * l擾.
	 *<p>
	 * NH[e[V͊܂܂ȂB
	 * </p>
	 *
	 * @return li݂ȂꍇAnullj
	 */
	public String getValue() {
		TextToken text = getValueToken();
		if (text != null) {
			return text.getText();
		}
		return null;
	}

	/**
	 * l擾.
	 *
	 * @param quote
	 *            truȅꍇANH[e[V܂ށB
	 * @return li݂ȂꍇAnullj
	 */
	public String getValue(boolean quote) {
		if (quote) {
			return getText();
		} else {
			return getValue();
		}
	}

	/**
	 * NH[e[V擾.
	 * <p>
	 * l̖̃NH[e[VB
	 * </p>
	 *
	 * @return NH[e[Vi݂ȂꍇAnullj
	 */
	public String getQuote2() {
		AtomToken q = getQuote2Atom();
		if (q == null) {
			return null;
		}
		return q.getAtom();
	}

	/**
	 * NH[e[V擾.
	 * <p>
	 * l̖̃NH[e[VB
	 * </p>
	 *
	 * @return NH[e[Vi݂ȂꍇAnullj
	 */
	public AtomToken getQuote2Atom() {
		return (AtomToken) get(Pos.END);
	}
}
