package jp.hishidama.html.parser.rule;

import java.util.*;

import jp.hishidama.html.lexer.rule.HtLexer;
import jp.hishidama.html.lexer.token.ListToken;
import jp.hishidama.html.lexer.token.Tag;
import jp.hishidama.html.lexer.token.Token;
import jp.hishidama.html.parser.elem.HtElement;
import jp.hishidama.html.parser.elem.HtListElement;
import jp.hishidama.html.parser.elem.HtTagElement;
import jp.hishidama.html.parser.elem.HtTokenElement;

/**
 * HtHtmlParser{.
 *<p>
 * {@link ListToken}ǂݍ݁A^Õc[\zB<br>
 * <a target="hishidama" href=
 * "http://www.ne.jp/asahi/hishidama/home/tech/soft/java/htlexer.html">gp</a>
 * </p>
 *
 * @author <a target="hishidama" href=
 *         "http://www.ne.jp/asahi/hishidama/home/tech/soft/java/htlexer.html"
 *         >Ђ</a>
 * @since 2009.02.08
 */
public class HtParser {

	protected boolean DEBUG = false;

	/**
	 * RXgN^[.
	 *
	 * @param name
	 *            vf
	 */
	protected HtParser(String name) {
		setName(name);
	}

	private String name;

	/**
	 * vfݒ.
	 *
	 * @param name
	 *            vf
	 */
	public final void setName(String name) {
		if (name != null) {
			this.name = name.toLowerCase();
		}
	}

	/**
	 * vf擾.
	 *
	 * @return vf
	 */
	public final String getName() {
		return name;
	}

	protected boolean noBody = false;

	/**
	 * {fB[Ȃvfǂݒ肷B
	 *
	 * @param b
	 *            truȅꍇA{fB[Ȃ
	 */
	public final void setNoBody(boolean b) {
		noBody = b;
	}

	/**
	 * {fB[ȂvfǂB
	 *
	 * @return truȅꍇA{fB[Ȃ
	 */
	public final boolean hasNoBody() {
		return noBody;
	}

	protected boolean ommitS = false;

	/**
	 * Jn^Oȗ\ǂݒ肷B
	 *
	 * @param b
	 *            truȅꍇAȗ\
	 */
	public final void setOmmitS(boolean b) {
		ommitS = b;
	}

	/**
	 * Jn^Oȗ\ǂB
	 *
	 * @return truȅꍇAȗ\
	 */
	public final boolean canOmmitS() {
		return ommitS;
	}

	protected boolean ommitE = false;

	/**
	 * I^Oȗ\ǂݒ肷B
	 *
	 * @param b
	 *            truȅꍇAȗ\
	 */
	public final void setOmmitE(boolean b) {
		ommitE = b;
	}

	/**
	 * I^Oȗ\ǂB
	 *
	 * @return truȅꍇAȗ\
	 */
	public final boolean canOmmitE() {
		return ommitE;
	}

	protected boolean block = false;

	/**
	 * ubNvfǂݒ肷B
	 *
	 * @param b
	 *            truȅꍇAubNvf
	 */
	public final void setBlock(boolean b) {
		block = b;
	}

	/**
	 * ubNvfǂB
	 *
	 * @return truȅꍇAubNvf
	 */
	public final boolean isBlock() {
		return block;
	}

	protected int prio = 0;

	/**
	 * Dx擾.
	 *
	 * @return D揈ɂDx
	 */
	protected final int getPriority() {
		return prio;
	}

	protected HtParserManager manager;

	protected final void setManager(HtParserManager manager) {
		this.manager = manager;
	}

	/**
	 * ͎s.
	 *
	 * @param tlist
	 *            Xgg[N
	 * @return vfXg
	 * @see HtLexer#parse()
	 */
	public HtListElement parse(ListToken tlist) {
		List<HtElement> elist = parseInit(tlist);
		parsePriority(elist, -1);
		parseList(elist, -1);

		HtListElement ret = new HtListElement();
		ret.setList(elist);
		return ret;

	}

	/**
	 * g[NXgvfXgoB
	 *
	 * @param tlist
	 * @return
	 */
	protected final List<HtElement> parseInit(ListToken tlist) {
		List<HtElement> elist = new ArrayList<HtElement>(tlist.size());
		for (Token t : tlist) {
			if (t instanceof Tag) {
				Tag tag = (Tag) t;
				if (tag.isStart() && tag.isEnd()) {
					// <`/>̏ꍇ
					HtTagElement te = new HtTagElement();
					te.setStartTag(tag);
					te.setFix(true);
					elist.add(te);
					continue;
				}
				String name = tag.getName();
				if (name == null || name.isEmpty()) {
					// Oꍇ
					HtTagElement ee = new HtTagElement();
					ee.setStartTag(tag);
					ee.setFix(true);
					elist.add(ee);
					continue;
				}

				HtElement e = new HtTokenElement(t);
				e.setFix(false);
				elist.add(e);
			} else {
				// ^OȊOieLXgj́AftHgŊm
				HtElement e = new HtTokenElement(t);
				e.setFix(true);
				elist.add(e);
			}
		}
		return elist;
	}

	/**
	 * Dx̍^O͂BiftHgp[T[gpj
	 *
	 * @param elist
	 * @param stag
	 * @return
	 */
	protected final int parsePriority(List<HtElement> elist, int stag) {
		HtParser p = manager.getDefaultParser();
		return p.parsePriority0(elist, stag);
	}

	/**
	 * Dx̍^O͂Bivf̎ޖj
	 *
	 * @param elist
	 * @param stag
	 * @return
	 */
	protected final int parsePriority0(List<HtElement> elist, int stag) {
		if (elist == null) {
			return -1;
		}
		for (int i = stag + 1; i < elist.size(); i++) {
			HtElement e = elist.get(i);
			if (!e.isTag()) {
				continue;
			}
			if (e.isStart() && e.isEnd()) {
				// vf̊JnƏI̗ꍇ
				// Ȃ킿<tag/>
				// ܂<tag>`</tag>
				continue;
			}

			int n = parsePriorityEnd(elist, stag, i, e);
			if (n >= 0) {
				i = n;
				return n;
			}

			if (e.isFix()) {
				continue;
			}

			if (e.isStart()) {
				String name = e.getName();
				HtParser p = manager.getParser(name);
				int pr = p.getPriority();
				if (pr > 0 && pr >= this.getPriority()) {
					n = p.parsePriority0(elist, i);
					if (n >= 0) {
						i = n;
						continue;
					}
				}
			}
		}
		return parsePriorityNotFound(elist, stag);
	}

	/**
	 * D揈ɂāAI̔sB
	 *
	 * @param elist
	 * @param stag
	 * @param pos
	 *            Ώۗvf̈ʒu
	 * @param e
	 *            Ώۗvf
	 * @return Iꍇ̈ʒu
	 */
	protected int parsePriorityEnd(List<HtElement> elist, int stag, int pos,
			HtElement e) {
		return -1;
	}

	/**
	 * D揈ɂāAI^Oꍇ̏sB
	 *
	 * @param elist
	 * @param stag
	 * @return
	 */
	protected int parsePriorityNotFound(List<HtElement> elist, int stag) {
		return -1;
	}

	/**
	 * ^Ovf.
	 *<p>
	 * ^OvfɕێĂevfɑ΂A͏ĂяoB<br>
	 * ̌ʁASĂmς݂ɂȂ^Ovfgmς݂ɂB
	 * </p>
	 *
	 * @param te
	 * @return
	 */
	protected boolean parseMain(HtTagElement te) {
		HtParser p = manager.getDefaultParser();
		p.parseList(te.getList(), -1);

		boolean fix = true;

		List<HtElement> list = te.getList();
		if (list != null) {
			for (int i = 0; i < list.size(); i++) {
				HtElement e = list.get(i);
				fix &= e.isFix();
			}
		}

		te.setFix(fix);
		return fix;
	}

	/**
	 * vfꗗ̊evfɑ΂A͏ĂяoB
	 *
	 * @param elist
	 * @param stag
	 * @return
	 */
	protected void parseList(List<HtElement> elist, int stag) {
		if (elist == null) {
			return;
		}
		parseNoBody(elist, stag);
		parsePair(elist, stag);
		parseProper(elist, stag);
		parseEndTag(elist, stag);
	}

	/**
	 * {fB[vfŏI^OȂ̂m肳B
	 *
	 * @param elist
	 * @param stag
	 */
	protected final void parseNoBody(List<HtElement> elist, int stag) {
		if (stag != -1) {
			return;
		}

		for (int i = elist.size() - 1; i >= stag + 1; i--) {
			HtElement e = elist.get(i);
			if (e.isFix()) {
				continue;
			}
			if (e instanceof HtTagElement) {
				HtTagElement te = (HtTagElement) e;
				parseMain(te);
				continue;
			}
			if (!e.isEnd()) {
				// Jn^O<tag>
				String name = e.getName();
				HtParser p = manager.getParser(name);
				if (p.hasNoBody()) {
					// {fB[vf
					int n = searchEndTag(elist, i + 1, name);
					if (n < 0) {
						// ̏I^OȂꍇ
						setFix(elist, i, -1, -1, -1);
					}
				}
			}
		}
	}

	/**
	 * }b`I^OTB
	 *
	 * @param elist
	 * @param pos
	 * @param name
	 * @return ꍇÄʒu
	 */
	protected final int searchEndTag(List<HtElement> elist, int pos, String name) {
		for (int i = pos; i < elist.size(); i++) {
			HtElement e = elist.get(i);
			if (!e.isTag()) {
				continue;
			}
			if (e.isStart() && e.isEnd()) {
				continue;
			}
			if (e.isEnd() && name.equalsIgnoreCase(e.getName())) {
				return i;
			}
		}
		return -1;
	}

	/**
	 * Jn^Oƕ^ÕyA΁Am肳B
	 *
	 * @param elist
	 * @param stag
	 */
	protected final void parsePair(List<HtElement> elist, int stag) {
		if (stag != -1) {
			return;
		}
		for (int i = elist.size() - 1; i >= stag + 1; i--) {
			HtElement e = elist.get(i);
			if (!e.isFix()) {
				if (e instanceof HtTokenElement && !e.isEnd()) {
					// m̊Jn^O<tag>̏ꍇ
					String name = e.getName();
					HtParser p = manager.getParser(name);
					p.parsePairSub(elist, i);
				}
			}
		}
	}

	/**
	 * ԂɊm肵̂Ԃ̕^O܂łm肳B
	 *
	 * @param elist
	 * @param stag
	 */
	protected final void parsePairSub(List<HtElement> elist, int stag) {
		assert name != null;

		for (int i = stag + 1; i < elist.size(); i++) {
			HtElement e = elist.get(i);
			if (!e.isTag()) {
				continue;
			}
			if (e.isStart() && e.isEnd()) {
				// vf̊JnƏI̗ꍇ
				// Ȃ킿<tag/>
				// ܂<tag>`</tag>
				continue;
			}
			if (e.isEnd() && name.equalsIgnoreCase(e.getName())) {
				// I^O</tag>̂݁AOv
				setFix(elist, stag, stag + 1, i - 1, i);
				return;
			}

			if (!e.isFix()) {
				return; // m肪_ŏI
			}
		}

		// 擪ȍ~SĊm肾I^Oꍇ
		parsePairNotFound(elist, stag);
	}

	/**
	 * 擪^Oȍ~SĊm肾I^Oꍇ
	 *
	 * @param elist
	 * @param stag
	 */
	protected void parsePairNotFound(List<HtElement> elist, int stag) {
		if (this.hasNoBody()) {
			// {fB[Ȃvf
			setFix(elist, stag, -1, -1, -1);
		} else if (this.canOmmitE()) {
			// I^Oȗ\ȗvf
			// 擪ȍ~SĂЂƂ̗vfƂĊm
			setFix(elist, stag, stag + 1, elist.size() - 1, -1);
		} else {
			if (DEBUG) {
				HtElement e = elist.get(stag);
				Token t = e.getStartTag();
				System.out.printf("check1[%d] %s%n", t.getLine(), e.getName());
			}
		}
	}

	/**
	 * vfL[ɂ.
	 *
	 * @param elist
	 * @param stag
	 */
	protected final void parseProper(List<HtElement> elist, int stag) {
		if (elist == null) {
			return;
		}

		for (int i = stag + 1; i < elist.size(); i++) {
			HtElement e = elist.get(i);
			if (!e.isTag()) {
				continue;
			}
			int n = parseProperCheckEnd(elist, stag, i, e); // m肵Ă邩ǂ֌WɃ`FbN
			if (n >= 0) {
				i = n;
				return;
			}
			if (e.isStart() && e.isEnd()) {
				continue;
			}
			if (e.isStart()) {
				// Jn^O
				if (!e.isFix()) {
					HtParser p = manager.getParser(e.getName());
					p.parseProper(elist, i);
				}
			} else {
				// I^O
				if (name != null && name.equalsIgnoreCase(e.getName())) {
					setFix(elist, stag, stag + 1, i - 1, i);
					return;
				}
			}
		}

		// ʂ菈I
		parseProperNotFound(elist, stag);
	}

	/**
	 * vfL[ɂI.
	 *
	 * @param elist
	 * @param stag
	 * @param pos
	 *            Ώۃ^Öʒu
	 * @param he
	 *            Ώۃ^O
	 * @return m肵ꍇÄʒu
	 */
	protected int parseProperCheckEnd(List<HtElement> elist, int stag, int pos,
			HtElement he) {
		return -1;
	}

	/**
	 * vfL[ɂďIɃXg̑S^OXLbvꂽꍇ̏
	 *
	 * @param elist
	 * @param stag
	 */
	protected void parseProperNotFound(List<HtElement> elist, int stag) {
		for (int i = elist.size() - 1; i > stag; i--) {
			HtElement e = elist.get(i);
			if (!e.isFix() && e.isStart() && !e.isEnd()) {
				// Jn^Ô݂̏ꍇ

				HtParser p = manager.getParser(e.getName());
				if (p.hasNoBody()) {
					// {fB[Ȃvf
					setFix(elist, i, -1, -1, -1);
				} else if (false && p.canOmmitE()) { // TODO
					// I^Oȗ\ȗvf
					// ܂őS{fB[ɓ
					setFix(elist, i, i + 1, elist.size() - 1, -1);
				} else {
					// ܂őS{fB[ɓ
					// setFix(elist, i, i + 1, elist.size() - 1, -1);
					if (DEBUG) {
						Token t = e.getStartTag();
						System.out.printf("check3[%d] %s%n", t.getLine(), e
								.getName());
					}
				}
			}
		}
	}

	/**
	 * m̏I^Ȍ
	 *
	 * @param elist
	 * @param stag
	 */
	protected final void parseEndTag(List<HtElement> elist, int stag) {
		if (stag != -1) {
			return;
		}

		for (int i = stag + 1; i < elist.size(); i++) {
			HtElement e = elist.get(i);
			if (!e.isFix() && !e.isStart() && e.isEnd()) {
				// m̏I^O</tag>
				HtParser p = manager.getParser(e.getName());
				int n = p.parseEndTagCheck(elist, i, e);
				if (n >= 0) {
					i = n;
					continue;
				}
			}
		}
	}

	/**
	 * ͂I^O
	 *
	 * @param elist
	 * @param etag
	 *            Ώۂ̏I^Öʒu
	 * @param he
	 *            Ώۂ̏I^O
	 * @return m肵ꍇA̐擪ʒu
	 */
	protected int parseEndTagCheck(List<HtElement> elist, int etag, HtElement he) {
		// ftHgł́A͂I^O
		if (this.hasNoBody()) {
			// {fB[Ȃvf
			setFix(elist, -1, -1, -1, etag);
			return etag;
		} else if (false && this.canOmmitS()) { // TODO
			// Jn^Oȗ\ȗvf
			// Xg̐擪炻̏I^O܂őSĂubN
			setFix(elist, -1, 0, etag - 1, etag);
			return 0;
		} else {
			// Xg̐擪炻̏I^O܂őSĂubN
			// setFix(elist, -1, 0, etag - 1, etag);
			// return 0;
			if (DEBUG) {
				HtElement e = elist.get(etag);
				Token t = e.getEndTag();
				System.out.printf("check4[%d] %s%n", t.getLine(), e.getName());
			}
			return -1;
		}
	}

	protected void setFix(List<HtElement> elist, int stag, int start, int end,
			int etag) {
		HtTagElement ne = setFix0(elist, stag, start, end, etag);
		parseMain(ne);
	}

	protected HtTagElement setFix0(List<HtElement> elist, int stag, int start,
			int end, int etag) {

		HtTagElement ne = new HtTagElement();
		if (stag >= 0) {
			ne.setStartTag(elist.get(stag).getStartTag());
		}
		if (etag >= 0) {
			ne.setEndTag(elist.get(etag).getEndTag());
		}

		if (start <= end && start > -1) {
			for (int i = start; i <= end; i++) {
				HtElement e = elist.get(i);
				ne.add(e);
			}
		}

		int min = elist.size(), max = -1;
		if (stag >= 0) {
			if (stag < min) {
				min = stag;
			}
			if (stag > max) {
				max = stag;
			}
		}
		if (start <= end) {
			if (start >= 0) {
				if (start < min) {
					min = start;
				}
				if (start > max) {
					max = start;
				}
			}
			if (end >= 0) {
				if (end < min) {
					min = end;
				}
				if (end > max) {
					max = end;
				}
			}
		}
		if (etag >= 0) {
			if (etag < min) {
				min = etag;
			}
			if (etag > max) {
				max = etag;
			}
		}
		for (int i = max; i >= min + 1; i--) {
			elist.remove(i);
		}
		elist.set(min, ne);

		return ne;
	}
}
